EDIT - task #3560

feature request # 7491 (New): [MASTER] Withheld unpublished taxa from webservice results and in DAOs

Withheld unpublished taxa from webservice used in E+M dataportal

06/26/2013 11:00 AM - Andreas Mdller

Status: Resolved Start date:

Priority: Highest Due date:

Assignee: Andreas Mller % Done: 70%
Category: cdmlib-remote Estimated time: 2:00 hours
Target version: Release 5.1

Severity: critical

Description

see also #1780, #3740, #3739

the following services have been secured.
AbstractldentifiableController:

e open:
o doGetTitleCache (not E+M)

BaseController:

¢ doGet
* open:
o doGetMethod

TaxonController:

doGetClassifications
doGetDescriptionElementsByType
doGetDescriptions

doGetFieldUnits

doGetTaggedName (not yet correct)

¢ doGetTaxonNodes (not yet correct)

e open:

o doGetIncludedTaxa

o doGetTaxonNodeAgentRelations
o doListSpecimensOrObservations
o getAcceptedFor

TaxonPortalController:

e doGetSynonymy
doGetTaxonNodes
doGetTaxonRelations
doGetMedia
doGetSubtreeMedia
doGetFromNameRelations
doGetToNameRelations

TaxonListController

doFind
dofindByEverythingFullText
doFindByFullText
doSearch
open:
o doFindBestMatchingTaxon
o dofindByDescriptionElementFull Text
o doFindByldentifier
o doFindByMarker
o doFindByNameParts
TaxonPortalListController
® no services

TaxonNodeController

e doPageChildNodes
* open:
o getParent()

ClassificationController

¢ getChildNodes
¢ getChildNodesAtRank
e getTaxonInContext
* open:
o getGroupedTaxaByHigherTaxon (not E+M)
o getGroupedTaxaByMarkedParents (not E+M)

ClassificationPortalController

e not relevant:
o getClassificationRootNode

ClassificationPortalListController

¢ getChildNodes

¢ getChildNodesAtRank

¢ getChildNodesOfTaxon

e getPathFromTaxon

e getPathFromTaxonToRank

¢ getSiblingsOfTaxon
ClassificationListController

® no services
DwcA-Controller:

¢ doDwcaTaxExport

General:

e open:
o check property paths in all controllers if they include taxa

o web-services from other controllers that return taxa as part of there result

Related issues:

Related to EDIT - feature request #3709: [E+M][Editor] sufficient rights mana...
Related to EDIT - feature request #3740: Allow recursively setting the publis...
Related to EDIT - bug #7745: Subtree filter for dataportal services

Related to EDIT - bug #7756: org.hibernate.QueryException in portal/taxon/{uu...
Related to EDIT - task #8424: evaluate publish flags in the full derivative path
Related to EDIT - feature request #4484: Evaluate publish flag for derivates ...
Related to EDIT - feature request #8875: Filter data portal by taxonomic rank

Related to EDIT - bug #9559: OccurrenceServicelmpl.findRootUnitDTOs() and rel...

Related to EDIT - feature request #10334: Evaluate DescriptionBase.publish in...
Precedes EDIT - feature request #7457: E+M: Allow filtering for only publishe...

Precedes EDIT - feature request #7492: Withheld unpublished taxa from webserv...

Resolved
Closed
Closed
Feedback
New

New

New

New
Closed
Closed
New
Associated revisions

Revision 2eddataf - 06/02/2018 04:17 PM - Andreas Muller
ref #3560 implement publish filter for TaxonNodeDao.listChildrenOf and .countChildrenOf

Revision 16fe90fd - 06/02/2018 06:02 PM - Andreas Mdller
ref #3560 implement publish filter for ClassificationDao.listChildrenOf and .countChildrenOf

Revision acebcf17 - 06/03/2018 02:21 PM - Andreas Miiller
ref #3560 add includeUnpublished for loadChildNodesOfTaxonNode in TaxEditor

Revision 43e22332 - 06/03/2018 02:26 PM - Andreas Miiller
ref #3560 add includeUnpublished for loadChildNodesOfTaxonNode in Vaadin

Revision 3¢1306f8 - 06/05/2018 04:10 PM - Andreas Miiller
ref #3560 use global "unpublished" constant

Revision bb8eecc0 - 06/05/2018 04:30 PM - Andreas Miuller

ref #3560 implement unpublished for load and find in service layer

Revision 78e8f961 - 06/05/2018 04:37 PM - Andreas Miiller

ref #3560 unpublished for doGetTaxonNodes and doGetTaggedName and doGetSubtreeMedia

Revision 12b3d645 - 06/05/2018 04:52 PM - Andreas Miuller

ref #3560 implement unpublished for taxon collection retrieval in occurrence service

Revision 62a08491 - 06/05/2018 05:39 PM - Andreas Miiller

ref #3560 implement unpublished for rankSpecificRootNode in service and remote (no tests yet)

Revision e073fc85 - 06/05/2018 06:00 PM - Andreas Miiller

ref #3560 implement unpublished for listSiblings in service and remote (no tests yet)

Revision 892f37a3 - 06/05/2018 06:26 PM - Andreas Miiller
ref #3560 implement unpublished in BaseController.doGet

Revision 547b40a1 - 06/05/2018 11:37 PM - Andreas Miiller
ref #3560 tests for unpublished listRankSpecificRootNodes

Revision 754a3c47 - 06/06/2018 11:45 PM - Andreas Miiller

ref #3560 implement publish in taxon service by name search

Revision 1301eb40 - 06/06/2018 11:59 PM - Andreas Miiller

ref #3560 implement publish in taxon service by name search

Revision 160717a9 - 06/07/2018 07:54 AM - Andreas Miiller
ref #3560 fix test in TaxEditor for findMatchingXXX

Revision b8dc9fef - 06/07/2018 03:01 PM - Andreas Miiller

ref #3560 set includeUnpublished as default for FindTaxaAndNames configurator

Revision 2d3df654 - 06/07/2018 03:03 PM - Andreas Miiller

ref #3560 search also for unpublished as default in TaxEditor

Revision cac97126 - 06/08/2018 12:17 AM - Andreas Miiller
ref #3560 implement loadTreeBranchToTaxon (pathTo) for unpublished

Revision d113f0b3 - 06/08/2018 09:44 AM - Andreas Miiller
ref #3560 add exception package to TaxEdtior

Revision 024216db - 06/08/2018 11:23 AM - Andreas Miiller
ref #3560 add publish flag to lucene index

Revision e293181b - 06/08/2018 01:21 PM - Andreas Miiller
ref #3560 add publish flag to lucene search

Revision df72b543 - 06/09/2018 12:23 AM - Andreas Miiller

ref #3560 fix pathFrom in classification service impl

Revision 7ac91dc0 - 06/11/2018 10:13 AM - Andreas Miller

ref #3560 further publish flag issues for lucene search and first tests on lucene search

Revision 95e2bd9c - 06/12/2018 02:15 PM - Andreas Miiller
ref #3560 try to add publish to synonym search in findTaxaAndNamesByFullText (probably not working yet)

Revision 37b63de0 - 06/12/2018 09:53 PM - Andreas Miiller

ref #3560 further improve full text taxonAndName search for publish flag, including tests

Revision 1771383 - 06/12/2018 09:53 PM - Andreas Miiller

ref #3560, ref #5477 fix missing lucene index update for synonyms and misapplied names

Revision 92a5fd30 - 06/13/2018 01:02 AM - Andreas Miiller

ref #3560 remove unpublished synonyms from taxon.synonymy

Revision 1e9f87b1 - 06/13/2018 01:50 AM - Andreas Miiller

ref #3560 handle access denied for unpublished data in some TaxonController methods

Revision 3e01938c¢ - 06/13/2018 02:03 AM - Andreas Miiller

ref #3560 remove unpublished synonyms from taxon.synonymy (fix)

Revision 7cfcc8f1 - 06/13/2018 02:26 AM - Andreas Miiller

ref #3560 handle access denied for unpublished data in BaseController.doGet

Revision 34337128 - 06/13/2018 02:37 AM - Andreas Miiller

ref #3560 remove unpublished synonyms from taxon.synonymy (handle homotypic syns correctly)

Revision 11fcf6af - 06/13/2018 01:36 PM - Andreas Miuiller

ref #3560 fix wrong method call in BaseController

Revision e08838f0 - 06/14/2018 12:51 AM - Andreas Miiller
ref #3560 add includeUnpublished for taxon relationships

Revision 0d028764 - 06/14/2018 10:36 PM - Andreas Miiller

ref #3560 fix includeUnpublished for taxon relationships and correct includePublished->includeUnpublished

Revision 53a4a1d9 - 06/21/2018 03:38 PM - Andreas Miiller
ref #3560 secured TaxonPortalController.doGetMedia and doGetSubtreeMedia

Revision 76bdf64b - 06/21/2018 03:48 PM - Andreas Miiller

ref #3560 secured TaxonPortalController.doGetFromNameRelations and doGetToNameRelations

Revision 87ffda36 - 06/22/2018 09:56 AM - Andreas Miiller
ref #3560 unpublished exception handling for TaxonController.doGetAcceptedFor

Revision d499114c - 06/22/2018 10:04 AM - Andreas Muller
ref #3560 unpublished exception handling for TaxonController.getPathFromTaxon(ToRank)

Revision bb006ee7 - 06/22/2018 12:14 PM - Andreas Miuller

ref #3560 fix checkPublished in service base class

Revision 68a8023a - 02/27/2019 05:02 PM - Andreas Miiller
ref #3560

Revision 67c8f20e - 06/04/2019 12:40 PM - Andreas Kohlbecker

ref #8321 implementing page by restriction method to allow for flexible web service queries, also protecting unpublished taxa and names ref #3560

History

#1 - 01/15/2014 06:32 PM - Andreas Kohlbecker

- Category changed from cdmserver to cdmlib-remote

#2 - 01/20/2014 06:02 PM - Andreas Kohlbecker

- Severity changed from critical to blocker

#3 - 01/21/2014 06:50 PM - Andreas Kohlbecker
- Priority changed from Priority08 to Highest
This must be implemented at the persistence level
e TaxonDao
e SpecimenDao

e Search functions

can we use Hibernate filtered collections for this?

#4 - 01/21/2014 06:51 PM - Andreas Kohlbecker
- Assignee changed from Andreas Kohlbecker to Andreas Miiller
- Category changed from cdmlib-remote to cdmlib

- Subject changed from Withheld unpublished taxa and specimen from webservice results to Withheld unpublished taxa and specimen from
webservice results and in DAOs

#5 - 01/27/2014 04:30 PM - Andreas Kohlbecker

- Severity changed from blocker to critical

for now we will use a second database for publishing, the entities marked as unpublished can be filtered out at the database level, so this issue is no
longer a blocker.

#6 - 05/02/2016 04:50 PM - Andreas Miiller
- Target version changed from CDM UML 3.3/3.4 - Postprocessing to Unassigned CDM tickets

#7 - 06/21/2016 10:46 AM - Andreas Miiller

- Target version changed from Unassigned CDM tickets to Euro+Med Portal Release

#8 - 12/13/2016 04:32 PM - Andreas Kohlbecker
- Tags set to phycobank, Euro+Med
- Description updated

- Due date set to 03/31/2016

this is crucial for the phycobank.

#9 - 06/20/2017 08:17 AM - Andreas Kohlbecker
- Related to feature request #3709: [E+M][Editor] sufficient rights management for E+M workflow added
#10 - 09/14/2017 12:01 AM - Andreas Miiller
- Related to feature request #3740: Allow recursively setting the publish bit for TaxonBase added

#11 - 05/25/2018 12:21 PM - Andreas Miiller
- Priority changed from Highest to Priority14
- Estimated time set to 15:00 h

#12 - 06/02/2018 01:14 PM - Andreas Miiller
- Due date deleted (03/31/2016)
- Status changed from New to In Progress

- Priority changed from Priority14 to Highest

#13 - 06/02/2018 04:37 PM - Andreas Miiller

- Description updated

#14 - 06/02/2018 05:22 PM - Andreas Miiller

- Description updated

#15 - 06/02/2018 06:15 PM - Andreas Miiller
- Description updated

- % Done changed from 0 to 10

#16 - 06/02/2018 06:56 PM - Andreas Miiller

- Description updated

#17 - 06/02/2018 07:11 PM - Andreas Miiller
- Description updated

- % Done changed from 10 to 20

#18 - 06/02/2018 07:13 PM - Andreas Miiller

- Description updated
#20 - 06/02/2018 07:15 PM - Andreas Miiller
- Subject changed from Withheld unpublished taxa and specimen from webservice results and in DAOs to Withheld unpublished taxa from webservice

results and in DAOs

#21 - 06/03/2018 03:16 PM - Andreas Miiller

- Description updated

#22 - 06/05/2018 05:45 PM - Andreas Miiller

- Description updated

#23 - 06/07/2018 01:56 PM - Andreas Miiller

- Description updated

#24 - 06/07/2018 02:07 PM - Andreas Miiller

- Description updated

#25 - 06/07/2018 03:06 PM - Andreas Miiller
- Precedes feature request #7457: E+M: Allow filtering for only published in search added

#26 - 06/11/2018 10:19 AM - Andreas Miuller

- Tags changed from phycobank, euro+med to phycobank, euro+med, search

#27 - 06/12/2018 10:33 PM - Andreas Miiller

- Target version changed from Euro+Med Portal Release to Release 5.1
#28 - 06/18/2018 03:36 PM - Andreas Miiller
- Parent task set to #7491

#29 - 06/18/2018 03:37 PM - Andreas Miiller

- Subject changed from Withheld unpublished taxa from webservice results and in DAOs to Withheld unpublished taxa from webservice used in E+M
dataportal

#30 - 06/18/2018 03:37 PM - Andreas Miiller
- % Done changed from 20 to 60

#31 - 06/18/2018 03:39 PM - Andreas Miiller

- Description updated

#32 - 06/18/2018 03:52 PM - Andreas Miiller

- Description updated

#33 - 06/18/2018 04:11 PM - Andreas Miiller

- Description updated

#34 - 06/18/2018 04:12 PM - Andreas Miiller

- Description updated

#35 - 06/18/2018 04:32 PM - Andreas Miiller

- Description updated

#36 - 06/18/2018 08:51 PM - Andreas Miiller

- Description updated

#37 - 06/18/2018 09:01 PM - Andreas Miiller

- Description updated

#38 - 06/18/2018 09:06 PM - Andreas Miiller

- Description updated

#39 - 06/19/2018 03:17 PM - Andreas Miiller

- Description updated

#40 - 06/19/2018 03:30 PM - Andreas Miiller

- Precedes feature request #7492: Withheld unpublished taxa from webservice used in other webservices added

#41 - 06/19/2018 03:31 PM - Andreas Miiller

- Category changed from cdmlib to cdmlib-remote

#42 - 06/19/2018 03:58 PM - Andreas Miiller

- Description updated

#43 - 06/19/2018 05:09 PM - Andreas Miiller

- Description updated

#44 - 06/19/2018 05:10 PM - Andreas Miiller
- % Done changed from 60 to 70
- Estimated time changed from 15:00 h to 2:00 h

#45 - 06/19/2018 05:13 PM - Andreas Miiller
- Description updated

- Status changed from In Progress to Resolved
- Assignee changed from Andreas Miiller to Andreas Kohlbecker

| still want to unify the handling of unpublished a bit, but maybe you can already start testing if there some services that urgently need to be protected
to not show unpublished data in the data portal.

The general usecase to protect ALL webservices to not show unpublished data is handled in #7492 and is not part of this ticket.

#46 - 06/20/2018 12:04 PM - Andreas Kohlbecker

Hi Andreas,

first of all | analyzed the logfile on the production server and created a statistics on all webservice calls that are send to the cdm-server.

By this we now have an overview on the webservice endpoints that are really used together with a usage count. The count corresponds to the number

of calls to this endpoint as seen in the logfile.

I quickly went over the logfile and marked all webservice endpoints which potentially need filtering by the publish flag. Endpoints marked yellow needs
further investigation, grey ones are ok. Other colors are explained in the sheet.

ws-endpoint-usage.ods

#47 - 06/20/2018 01:50 PM - Andreas Kohlbecker

- File ws-endpoint-usage.ods added

#48 - 06/20/2018 09:37 PM - Andreas Miiller

Andreas Kohlbecker wrote:
first of all | analyzed the logfile on the production server and created a statistics on all webservice calls that are send to the cdm-server.
By this we now have an overview on the webservice endpoints that are really used together with a usage count. The count corresponds to the
number of calls to this endpoint as seen in the lodfile.
| quickly went over the logfile and marked all webservice endpoints which potentially need filtering by the publish flag. Endpoints marked yellow
needs further investigation, grey ones are ok. Other colors are explained in the sheet.

How do we want report further results/improvements? Handling in ods is not comfortable if 2 people work on it.

Some of the yellow services are already checked. See the overview in the ticket description.

#49 - 06/21/2018 09:56 AM - Andreas Kohlbecker

- File ws-endpoint-usage.ods added

| updated the ws-endpoint-usage.ods spread sheet by the information from the issue description.

There are now only few controller methods left which need to be checked.

Andreas

#50 - 06/21/2018 10:05 AM - Andreas Kohlbecker

- File deleted (ws-endpoint-usage.ods)

#51 - 06/21/2018 10:39 AM - Andreas Miuiller

- Description updated

#52 - 06/21/2018 11:17 AM - Andreas Kohlbecker

- File ws-endpoint-usage.ods added

#53 - 06/21/2018 11:17 AM - Andreas Kohlbecker

- File deleted (ws-endpoint-usage.ods)

#54 - 06/21/2018 03:40 PM - Andreas Miiller

- Description updated
secured TaxonPortalController.doGetMedia and doGetSubtreeMedia

#55 - 06/21/2018 03:56 PM - Andreas Miiller
- Description updated

secured TaxonPortalController.doGetFromNameRelations and doGetToNameRelations

#56 - 06/28/2018 12:23 AM - Andreas Miiller

- Private changed from Yes to No

#57 - 07/02/2018 10:45 AM - Andreas Miiller

- Assignee changed from Andreas Kohlbecker to Andreas Miiller

#58 - 08/15/2018 06:13 PM - Andreas Miiller

- File ws-endpoint-usage.ods added

#59 - 08/15/2018 06:13 PM - Andreas Miiller

- File deleted (ws-endpoint-usage.ods)

#60 - 09/09/2018 11:34 PM - Andreas Miiller
- Related to bug #7745: Subtree filter for dataportal services added

#61 - 09/12/2018 03:44 PM - Andreas Kohlbecker

- Related to bug #7756: org.hibernate.QueryException in portal/taxon/{uuid}/subtree/media.json webservice related to relation direction param in
prepare TaxonRelationshipQuery() added

#62 - 01/18/2019 07:26 AM - Andreas Kohlbecker

- Tags changed from phycobank, euro+med, search to phycobank, euro+med, search, security, permission

#63 - 06/04/2019 12:30 PM - Andreas Kohlbecker

- Description updated

#64 - 06/04/2019 12:30 PM - Andreas Kohlbecker

- Description updated
#65 - 06/04/2019 12:40 PM - Andreas Miiller
Can you please adapt the new information on doPageByRestrictions to the logic of the rest of the list? In general we follow the logic that the list shows

the already secured web-services. Explicitly open issues are listed in an open: list. Same for not relevant:

#66 - 06/04/2019 12:44 PM - Andreas Miiller

Also this ticket is only about E+M data portal relevant webservices. For other webservices please use #7492.

#67 - 06/04/2019 12:46 PM - Andreas Miiller

Be aware that this ticket has already status resolved in 5.1. It's task description should not be enlarged anymore if not absolutely needed.

#68 - 06/04/2019 05:44 PM - Andreas Kohlbecker

- Description updated

#69 - 06/04/2019 05:46 PM - Andreas Kohlbecker

| cleaned the ticket up as requested

#72 - 08/08/2019 09:35 AM - Andreas Miiller
- Related to task #8424: evaluate publish flags in the full derivative path added

#73 - 11/18/2019 01:41 PM - Andreas Miiller
- Related to feature request #4484: Evaluate publish flag for derivates in data portal added

#74 - 03/05/2020 10:31 AM - Andreas Miiller
- Related to feature request #8875: Filter data portal by taxonomic rank added

03/20/2024 9/10


https://dev.e-taxonomy.eu/redmine/issues/7492

#75 - 03/26/2021 01:54 PM - Andreas Miiller

- Related to bug #9559: OccurrenceServicelmpl.findRootUnitDTOs() and related methods suppress unpublished units added

#79 - 05/28/2023 01:02 PM - Andreas Miiller

- Related to feature request #10334: Evaluate DescriptionBase.publish in webservices added

Files
ws-endpoint-usage.ods 23.2 KB 08/15/2018

Andreas Muller
